<meta charset="utf-8">
<h1>JavaScript Básico</h1>
<script>

    "use strict"; 

    var a = 888;
    if (true) {
        var b = 999;
    }

    console.log('O valor de a é:', a); // 888
    console.log('O valor de b é:', b); // 999 - "b" também é acessível

    function teste1() {
        var idade = 17;
        console.log('Idade dentro da função:', idade); // Ok exibe 17
    }

    teste1(); // executa a função

    // console.log('Idade fora da função:', idade); // ReferenceError

    // Variáveis com "let"
    let c = 777; // variável global
    if (true) {
        let d = c; // OK, "c" é visível aqui
        console.log('Valor de D:', d); // OK
    }

    // console.log('D fora do if:', d); // ReferenceError: d não existe

    // Constantes em JavaScript
    const x = 0;
    // x = 2; // TypeError

    const listaNomes = ['Adriana', 'Fabiana', 'Rodrigo'];
    listaNomes.push('Gabriel'); // adicionamos um nome à lista
    listaNomes.shift(); // remove o primeiro nome da lista
    listaNomes[1] = 'Henrique'; // altera o valor da posição 1 do array
    console.log(listaNomes);

    const animais = ['Gato', 'Cachorro', 'Rato'];
    // animais = [] // TypeError: estamos atribuindo um novo valor à constante por completo

    // objeto simples
    const pessoa = {
        nome: "Roberto",
        sobrenome: "Albuquerque",
        idade: 35
    }

    // alterando o valor de uma propriedade
    pessoa.nome = "Gabriel"; // ok

    // adicionando uma propriedade nova ao objeto
    pessoa.sexo = "M"; // ok

    // contudo, caso tente atribuir um valor novo à constante por completo...
    // temos um erro
    // pessoa = {} // TypeError: reatribuição inválida

    somar(10, 3); // chama a função antes de sua declaração
    function somar(valor1, valor2) {
        console.log('Resultado:', valor1 + valor2);
    }

    // subtrair(5, 2); // Erro
    let subtrair = function(valor1, valor2) {
        console.log('Resultado da substração: ', valor1 - valor2);
    }
    subtrair(5, 2);

    // escopo vazio
    {
        // função só existe nesse escopo
        function testando(nome) 
        {
            console.log('Seu nome é: ', nome);
        }

        // exportamos a função para o escopo global
        // criamos uma propriedade chamada testandoFuncao no objeto global
        // e guardamos nela a referência da função "testando"
        window.testandoFuncao = testando;
    }

    // OK: já que a função foi exposta com o nome "testandoFuncao" já 
    // é possível a usarmos pois ao ser associada a window ela deixa de ser
    // um recurso "local" para virar um recurso "global" dentro do programa.
    testandoFuncao('Maurício');
    
</script>